// AcqDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "AcqDlg.h"
#include "Bkdoc.h"
#include "Tektro.h"
#include "Regres.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CAcqDlg dialog
CAcqDlg::CAcqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcqDlg)
	m_sTexte = _T("");
	m_radioTypeOscillo = -1;
	m_OKRef1 = FALSE;
	m_OKRef2 = FALSE;
	m_OKVoie1 = FALSE;
	m_OKVoie2 = FALSE;
	m_OKMath = FALSE;
	m_OkPara = FALSE;
	//}}AFX_DATA_INIT
}
void CAcqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcqDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDACQUERIR, m_btnAcq);
	DDX_Text(pDX, IDC_STATIC_INFO_ACQ, m_sTexte);
	DDX_Radio(pDX, IDC_TYPE0, m_radioTypeOscillo);
	DDX_Check(pDX, IDC_REF1, m_OKRef1);
	DDX_Check(pDX, IDC_REF2, m_OKRef2);
	DDX_Check(pDX, IDC_VOIE1, m_OKVoie1);
	DDX_Check(pDX, IDC_VOIE2, m_OKVoie2);
	DDX_Check(pDX, IDC_MATH, m_OKMath);
	DDX_Check(pDX, IDC_PARA, m_OkPara);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcqDlg, CDialog)
	//{{AFX_MSG_MAP(CAcqDlg)
	ON_BN_CLICKED(IDACQUERIR, OnAcquerir)
	ON_BN_CLICKED(IDC_REF1, OnRef1)
	ON_BN_CLICKED(IDC_REF2, OnRef2)
	ON_BN_CLICKED(IDC_VOIE1, OnVoie1)
	ON_BN_CLICKED(IDC_VOIE2, OnVoie2)
	ON_BN_CLICKED(IDC_MATH, OnMath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CAcqDlg message handlers
void CAcqDlg::GestionBoutons(void)
{
	short nb=0;
	GetDlgItem(IDC_VOIE1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_VOIE2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_MATH)->EnableWindow(TRUE);         
	if (m_OKVoie1) nb++;
	if (m_OKVoie2) nb++;
	if (m_OKRef1) nb++;
	if (m_OKRef2) nb++;
	if (m_OKMath) nb++;
	if (nb>1)
	{
		if (!m_OKVoie1) GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);
		if (!m_OKVoie2) GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);
		if (!m_OKRef1) GetDlgItem(IDC_REF1)->EnableWindow(FALSE);
		if (!m_OKRef2) GetDlgItem(IDC_REF2)->EnableWindow(FALSE);
		if (!m_OKMath) GetDlgItem(IDC_MATH)->EnableWindow(FALSE);
	}

	if (!m_OKVoie1 && !m_OKVoie2 && !m_OKRef1 && !m_OKRef2 && !m_OKMath)	
		m_btnAcq.EnableWindow(FALSE);
	else
	if (m_ok)
		m_btnAcq.EnableWindow(TRUE);
}
//__________________________________________________
BOOL CAcqDlg::AffectationTableau(char col1,char col2)
{
	BOOL ok=TRUE;
	short k,i,j;
	int curv;
	char
		c,s[30];

	//AfxMessageBox(m_pTektro->m_cBuf);
	i=0;j=0;m_pDoc->m_iNb=0;
	while (i<strlen(m_pTektro->m_cBuf))
	{
		c=m_pTektro->m_cBuf[i];
		if (c!=',')
		{
			s[j]=c;
			j++;
		} 
		else
		{
			//Extraction et affectation tableau
			s[j]='\0';
		 	k=sscanf(s,"%d",&curv);
 			if (k==1 && m_pDoc->m_iNb<m_pDoc->m_iNbMax)
 			{
 				m_pDoc->m_fT[m_pDoc->m_iNb][col1]=m_pDoc->m_iNb;
 				m_pDoc->m_fT[m_pDoc->m_iNb][col2]=curv;
				m_pDoc->m_fT[m_pDoc->m_iNb][col1]=m_pTektro->m_xincr*m_pDoc->m_fT[m_pDoc->m_iNb][col1]-m_pTektro->m_xincr*m_pTektro->m_pt_off;
				m_pDoc->m_fT[m_pDoc->m_iNb][col2]=m_pTektro->m_yzero+m_pTektro->m_ymult*(m_pDoc->m_fT[m_pDoc->m_iNb][col2]-m_pTektro->m_yoff);
				m_pDoc->m_iNb++;
				j=0;
			}
		}
		i++;
	}
	if (m_pDoc->m_iNb>m_pDoc->m_iNbMax-1)
	{
		//Dpassement taille tableau
		m_pDoc->m_iNb=0;
		ok=FALSE;
		AfxMessageBox("Dpassement taille tableau m_fT");
	}
	return ok;
}
//__________________________________________________
BOOL CAcqDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	//Informations concernant l'acquisition
	m_pDoc->m_sTab.RemoveAll();
	m_pDoc->m_sTab.Add("ACQ. OSCILLOSCOPE TEKTRONIX");
	m_pDoc->m_sTab.Add("Nom(s)/Prnom(s):");
	m_pTektro=new CTektro(m_pDoc->m_radioPortSerie);

	if (m_pDoc->m_iTypeAcq&1) m_OKVoie1=TRUE;
	if (m_pDoc->m_iTypeAcq&2) m_OKVoie2=TRUE;
	if (m_pDoc->m_iTypeAcq&4) m_OKRef1=TRUE;
	if (m_pDoc->m_iTypeAcq&8) m_OKRef2=TRUE;
	if (m_pDoc->m_iTypeAcq&16) m_OKMath=TRUE;
	m_sTexte="Slectionner les voies d'acquisition, puis cliquer sur Acqurir.";

	GestionBoutons();

	//Format des donnes et test criture sur port
	m_ok=m_pTektro->WriteCom("DATA:ENCDG ASCII\n");
	if (m_ok)
	{
		//Identification oscilloscope
		s=m_pTektro->Identification();
		if (strstr(s,"TDS 3")) m_radioTypeOscillo=1; else m_radioTypeOscillo=0;
	}
	if (!m_ok)
	{
		m_sTexte.Format("Erreur d'criture sur le port srie n%d !",m_pDoc->m_radioPortSerie+1);
		m_btnAcq.EnableWindow(FALSE);

	}
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CAcqDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
void CAcqDlg::OnCancel() 
{
	UpdateData(TRUE);
	m_pDoc->m_iTypeAcq=0;
	if (m_OKVoie1) m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+1;
	if (m_OKVoie2) m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+2;
	if (m_OKRef1) m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+4;
	if (m_OKRef2) m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+8;
	if (m_OKMath) m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+16;
	delete m_pTektro;
	CDialog::OnCancel();
}
//__________________________________________________
void CAcqDlg::OnAcquerir() 
{
	BOOL ok;
	short col=0;
	CString s;

	UpdateData(TRUE);

	if (m_OkPara)
	{
		m_pDoc->m_OKinfo=TRUE;
	}
	m_btnCancel.EnableWindow(FALSE);
	m_btnAcq.EnableWindow(FALSE);
	GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);         
	GetDlgItem(IDC_REF1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_REF2)->EnableWindow(FALSE);         
	GetDlgItem(IDC_MATH)->EnableWindow(FALSE);         
	GetDlgItem(IDC_TYPE0)->EnableWindow(FALSE);         
	GetDlgItem(IDC_TYPE1)->EnableWindow(FALSE);         
	GetDlgItem(IDC_PARA)->EnableWindow(FALSE);         
	//En fonction de la voie d'acquisition...
	m_pDoc->m_iTypeGr=0;
	m_pDoc->m_iTypeAcq=0;
	if (m_OKVoie1)
	{
		//Voie 1
		ok=m_pTektro->SelectionVoie("CH1");
		if (ok)	ok=m_pTektro->LectureParametres("CH1",m_radioTypeOscillo);
		if (m_pTektro->m_nr_pt>50 && ok)
		{
			m_sTexte.Format("CH1 - NR_PT: %d, PT_Off: %d\nXINcr: %1.0e, YMULt: %1.0e\nYZEro: %1.0e, YOFf: %1.0e\nLecture donnes CURVE en cours...",m_pTektro->m_nr_pt,m_pTektro->m_pt_off,m_pTektro->m_xincr,m_pTektro->m_ymult,m_pTektro->m_yzero,m_pTektro->m_yoff);
			UpdateData(FALSE);
			//Lecture donnes oscilloscope et affectation m_cBuf
			ok=m_pTektro->Curve();
			//Affectation colonnes
			if (ok) AffectationTableau(col,col+1);
			col=col+2;
			m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+1;
			//On visualise ce qu'on a acquis...
			m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+1;
		}
		m_sTexte.Format("Fin d'acquisition CH1.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,strlen(m_pTektro->m_cBuf));

		//Paramtres complmentaires
		if (m_OkPara)
		{
			s=m_pTektro->ParaCompl("CH1","AMPLitude");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("CH1","CMEan");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("CH1","CRMs");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("CH1","FREQuency");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
		}
		UpdateData(FALSE);
		//On invalide le trac des rgressions
		m_pDoc->m_pReg->Invalider();
		m_pDoc->UpdateAllViews(NULL);
	}
	if (m_OKVoie2)
	{
		//Voie 2
		ok=m_pTektro->SelectionVoie("CH2");
		if (ok)	ok=m_pTektro->LectureParametres("CH2",m_radioTypeOscillo);
		if (m_pTektro->m_nr_pt>50 && ok)
		{
			m_sTexte.Format("CH2 - NR_PT: %d, PT_Off: %d\nXINcr: %1.0e, YMULt: %1.0e\nYZEro: %1.0e, YOFf: %1.0e\nLecture donnes CURVE en cours...",m_pTektro->m_nr_pt,m_pTektro->m_pt_off,m_pTektro->m_xincr,m_pTektro->m_ymult,m_pTektro->m_yzero,m_pTektro->m_yoff);
			UpdateData(FALSE);
			//Lecture donnes oscilloscope et affectation m_cBuf
			ok=m_pTektro->Curve();
			//Affectation colonnes
			if (ok) AffectationTableau(col,col+1);
			col=col+2;
			m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+2;
			m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+2;
		}
		m_sTexte.Format("Fin d'acquisition CH2.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,strlen(m_pTektro->m_cBuf));
		
		//Paramtres complmentaires
		if (m_OkPara)
		{
			s=m_pTektro->ParaCompl("CH2","AMPLitude");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("CH2","CMEan");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("CH2","CRMs");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("CH2","FREQuency");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
		}
		UpdateData(FALSE);
		//On invalide le trac des rgressions
		m_pDoc->m_pReg->Invalider();
		m_pDoc->UpdateAllViews(NULL);
	}
	if (m_OKRef1)
	{
		//Ref 1
		ok=m_pTektro->SelectionVoie("REF1");
		if (ok)	ok=m_pTektro->LectureParametres("REF1",m_radioTypeOscillo);
		if (m_pTektro->m_nr_pt>50 && ok)
		{
			m_sTexte.Format("REF1 - NR_PT: %d, PT_Off: %d\nXINcr: %1.0e, YMULt: %1.0e\nYZEro: %1.0e, YOFf: %1.0e\nLecture donnes CURVE en cours...",m_pTektro->m_nr_pt,m_pTektro->m_pt_off,m_pTektro->m_xincr,m_pTektro->m_ymult,m_pTektro->m_yzero,m_pTektro->m_yoff);
			UpdateData(FALSE);
			ok=m_pTektro->Curve();
			//Affectation colonnes 
			if (ok) AffectationTableau(col,col+1);
			col=col+2;
			m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+4;
			m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+4;
		}
		m_sTexte.Format("Fin d'acquisition REF1.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,strlen(m_pTektro->m_cBuf));
		//Paramtres complmentaires
		if (m_OkPara)
		{
			s=m_pTektro->ParaCompl("REF1","AMPLitude");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("REF1","CMEan");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("REF1","CRMs");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("REF1","FREQuency");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
		}
		UpdateData(FALSE);
		//On invalide le trac des rgressions
		m_pDoc->m_pReg->Invalider();
		m_pDoc->UpdateAllViews(NULL);
	}
	if (m_OKRef2)
	{
		//Ref 2
		ok=m_pTektro->SelectionVoie("REF2");
		if (ok)	ok=m_pTektro->LectureParametres("REF2",m_radioTypeOscillo);
		if (m_pTektro->m_nr_pt>50 && ok)
		{
			m_sTexte.Format("REF2 - NR_PT: %d, PT_Off: %d\nXINcr: %1.0e, YMULt: %1.0e\nYZEro: %1.0e, YOFf: %1.0e\nLecture donnes CURVE en cours...",m_pTektro->m_nr_pt,m_pTektro->m_pt_off,m_pTektro->m_xincr,m_pTektro->m_ymult,m_pTektro->m_yzero,m_pTektro->m_yoff);
			UpdateData(FALSE);
			//Lecture donnes oscilloscope et affectation m_cBuf
			ok=m_pTektro->Curve();
			//Affectation colonnes
			if (ok) AffectationTableau(col,col+1);
			m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+8;
			m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+8;
		}
		m_sTexte.Format("Fin d'acquisition REF2.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,strlen(m_pTektro->m_cBuf));
		//Paramtres complmentaires
		if (m_OkPara)
		{
			s=m_pTektro->ParaCompl("REF2","AMPLitude");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("REF2","CMEan");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("REF2","CRMs");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("REF2","FREQuency");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
		}
		UpdateData(FALSE);
		//On invalide le trac des rgressions
		m_pDoc->m_pReg->Invalider();
		m_pDoc->UpdateAllViews(NULL);
	}
	if (m_OKMath)
	{
		//Math
		ok=m_pTektro->SelectionVoie("MATH");
		if (ok)	ok=m_pTektro->LectureParametres("MATH",m_radioTypeOscillo);
		if (m_pTektro->m_nr_pt>50 && ok)
		{
			m_sTexte.Format("MATH - NR_PT: %d, PT_Off: %d\nXINcr: %1.0e, YMULt: %1.0e\nYZEro: %1.0e, YOFf: %1.0e\nLecture donnes CURVE en cours...",m_pTektro->m_nr_pt,m_pTektro->m_pt_off,m_pTektro->m_xincr,m_pTektro->m_ymult,m_pTektro->m_yzero,m_pTektro->m_yoff);
			UpdateData(FALSE);
			//Lecture donnes oscilloscope et affectation m_cBuf
			ok=m_pTektro->Curve();
			//Affectation colonnes
			if (ok) AffectationTableau(col,col+1);
			m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+16;
			m_pDoc->m_iTypeAcq=m_pDoc->m_iTypeAcq+16;
		}
		m_sTexte.Format("Fin d'acquisition MATH.\n%d valeurs crites dans le tableau.\n(%d)",m_pDoc->m_iNb+1,strlen(m_pTektro->m_cBuf));
		//Paramtres complmentaires
		if (m_OkPara)
		{
			s=m_pTektro->ParaCompl("MATH","AMPLitude");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("MATH","CMEan");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("MATH","CRMs");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
			s=m_pTektro->ParaCompl("MATH","FREQuency");if (s.GetLength()!=0) m_pDoc->m_sTab.Add(MiseEnForme(s));
		}
		UpdateData(FALSE);
		//On invalide le trac des rgressions
		m_pDoc->m_pReg->Invalider();
		m_pDoc->UpdateAllViews(NULL);
	}
	m_btnCancel.EnableWindow(TRUE);
	m_btnAcq.EnableWindow(TRUE);
	GetDlgItem(IDC_VOIE1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_VOIE2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_REF2)->EnableWindow(TRUE);         
	GetDlgItem(IDC_MATH)->EnableWindow(TRUE);         
	GetDlgItem(IDC_TYPE0)->EnableWindow(TRUE);         
	GetDlgItem(IDC_TYPE1)->EnableWindow(TRUE);         
	GetDlgItem(IDC_PARA)->EnableWindow(TRUE);         
	GestionBoutons();
}
//__________________________________________________
void CAcqDlg::OnRef1() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//__________________________________________________
void CAcqDlg::OnRef2() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//__________________________________________________
void CAcqDlg::OnVoie1() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//__________________________________________________
void CAcqDlg::OnVoie2() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//__________________________________________________
void CAcqDlg::OnMath() 
{
	UpdateData(TRUE);
	GestionBoutons();
}
//__________________________________________________
CString CAcqDlg::MiseEnForme(CString s) 
{
	int i;
	float r;
	CString s1;
	i=sscanf(s,"%e",&r);
	if (i==0)
		return s;
	else
	{
		s1.Format("%1.3e",r);
		return s1;
	}
}