// RetroDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "RetroDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CRetroDlg dialog
CRetroDlg::CRetroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRetroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRetroDlg)
	m_fIndice = 0.0f;
	m_fURef = 0.0f;
	m_radioVoie = -1;
	//}}AFX_DATA_INIT
}
void CRetroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRetroDlg)
	DDX_Text(pDX, IDC_INDICE, m_fIndice);
	DDX_Text(pDX, IDC_UREF, m_fURef);
	DDX_Radio(pDX, IDC_VOIE_1, m_radioVoie);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CRetroDlg, CDialog)
	//{{AFX_MSG_MAP(CRetroDlg)
	ON_BN_CLICKED(IDCALCULER, OnCalculer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CRetroDlg message handlers
BOOL CRetroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	if(m_pDoc->m_iTypeGr & 1) m_radioVoie=0;
	else         
	if(m_pDoc->m_iTypeGr & 2) m_radioVoie=1;         
	else
	if(m_pDoc->m_iTypeGr & 4) m_radioVoie=2;
	else
	if(m_pDoc->m_iTypeGr & 8) m_radioVoie=3;         
	else
	if(m_pDoc->m_iTypeGr & 16) m_radioVoie=4;
	else
	{
		//Le graphe prcdent n'tait pas un graphe d'acq. mais de calcul...
		if(m_pDoc->m_iTypeAcq & 1) m_radioVoie=0;
		else         
		if(m_pDoc->m_iTypeAcq & 2) m_radioVoie=1;         
		else
		if(m_pDoc->m_iTypeAcq & 4) m_radioVoie=2;
		else
		if(m_pDoc->m_iTypeAcq & 8) m_radioVoie=3;         
		else
		if(m_pDoc->m_iTypeAcq & 16) m_radioVoie=4;
	}         
	m_fURef=m_pDoc->m_fURef;
	m_fIndice=m_pDoc->m_fIndice;
	UpdateData(FALSE);
	if(!(m_pDoc->m_iTypeAcq & 1)) GetDlgItem(IDC_VOIE_1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 2)) GetDlgItem(IDC_VOIE_2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 4)) GetDlgItem(IDC_REF_1)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 8)) GetDlgItem(IDC_REF_2)->EnableWindow(FALSE);         
	if(!(m_pDoc->m_iTypeAcq & 16)) GetDlgItem(IDC_MAT)->EnableWindow(FALSE);         
	return TRUE;
}
//__________________________________________________
void CRetroDlg::OnCalculer() 
{
	short 
		colT,colU,i,j;
	UpdateData(TRUE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&colT,&colU);			
	m_fURef=0;
	j=0;
	for (i=10;i<40;i++)
	{
		if (m_pDoc->m_fT[i][colU]!=1e10)
		{
			m_fURef=m_fURef+m_pDoc->m_fT[i][colU];
			j++;
		}
	}                              
	if (j!=0)
		m_fURef=m_fURef/j;                   
	else
		m_fURef=0;                   
	if (m_fURef>=1e9) m_fURef=0;
	UpdateData(FALSE);
}
//__________________________________________________
void CRetroDlg::OnOK() 
{
	float 
		l,a,t,u;
	short 
		i,colU,colT;
	UpdateData(TRUE);
	if (m_fIndice<1) m_fIndice=1;
	if (m_fIndice>1.8) m_fIndice=1.8;
	m_pDoc->m_fURef=m_fURef;
	m_pDoc->m_fIndice=m_fIndice;
	//Calcul graphe de rtrodiffusion
	UpdateData(FALSE);
	m_pDoc->ColonnesTableau((int)(pow(2,m_radioVoie)),&colT,&colU);	
	
	for (i=0;i<m_pDoc->m_iNbMax;i++)
	{
		t=m_pDoc->m_fT[i][colT];
		u=m_pDoc->m_fT[i][colU];
		if (t!=1e10 && u!=1e10)
		{
			l=(float)(3e5*t/m_fIndice/2);
			if (u-m_fURef>0)
				a=(float)(5*log10(u-m_fURef));
			else
				a=1e10;
		}
		else
		{
			l=1e10;
			a=1e10;
		}
		m_pDoc->m_fT[i][4]=l;
		m_pDoc->m_fT[i][5]=a;
	}
	m_pDoc->m_iTypeGr=32;
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
