// Tektro.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "tektro.h"
//Indicateur de progression standard
#include "progdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
CTektro::CTektro(int iNoCom)
{
  //Buffer contenant les donnes envoyes
	m_iTailleBuf=10100/*9000*/;                
	m_cBuf=new char[m_iTailleBuf];
	//Port srie chromex
	m_radioCom=iNoCom;
	m_lTimeOut=1000;
	switch (m_radioCom)
	{
		case 0://COM1
			hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if (hCom==INVALID_HANDLE_VALUE)
			{
				DWORD dwErreur=GetLastError();
			}
			else
				InitRs232(hCom,&cfg,&ctmo,m_lTimeOut);
		break;
		case 1://COM2
			hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if (hCom==INVALID_HANDLE_VALUE)
				DWORD dwErreur=GetLastError();
			else
				InitRs232(hCom,&cfg,&ctmo,m_lTimeOut);
		break;
	}
}
//__________________________________________________
CTektro::~CTektro()
{
	if (hCom) CloseHandle(hCom);
	delete[] m_cBuf;	
}
//__________________________________________________
BOOL CTektro::InitRs232(HANDLE hCom,COMMCONFIG *cfg,COMMTIMEOUTS *ctmo,long lTimeOut)
{
	BOOL ok=TRUE;
	DCB dcb;
	//Paramtres du port srie
	//9600,8,'N',1, RTS/CTS
	dcb.fOutxCtsFlow=1;
	dcb.fOutxDsrFlow=0;
	dcb.fDtrControl=1;
	dcb.fDsrSensitivity=0;
	dcb.BaudRate=CBR_9600;
	dcb.fParity=1;
	dcb.fTXContinueOnXoff=1;
	dcb.fOutX=0;
	dcb.fInX=0;
	dcb.fErrorChar=0;
	dcb.fNull=0;
	dcb.fRtsControl=2;
	dcb.fAbortOnError=1;
	dcb.fDummy2=0;
	dcb.XonLim=2048;
	dcb.XoffLim=512;
	dcb.ByteSize=8;
	dcb.Parity=0;
	dcb.StopBits=0;
	dcb.XonChar=17;
	dcb.XoffChar=19;
	dcb.ErrorChar=0;
	dcb.EofChar='\r';
	dcb.EvtChar=0;
	SetCommState(hCom,&dcb);
	ok=GetCommTimeouts(hCom,ctmo);
	if (ok)
	{
		ctmo->ReadIntervalTimeout=100;
		ctmo->ReadTotalTimeoutMultiplier=2;
		ctmo->ReadTotalTimeoutConstant=lTimeOut;
		ctmo->WriteTotalTimeoutConstant=lTimeOut;
		ctmo->WriteTotalTimeoutMultiplier=2;
		SetCommTimeouts(hCom,ctmo);
	}
	return ok;
}
//__________________________________________________
BOOL CTektro::WriteCom(CString s)
{
	BOOL ok;
	DWORD i;
	ok=WriteFile(hCom,s,s.GetLength(),&i,NULL);
	if (!ok || i!=s.GetLength())
	{
		ok=FALSE;
	}
	return ok;
}
//__________________________________________________
BOOL CTektro::ReadCom(void)
{
	BOOL ok=TRUE;
	//Les caractres retourns sont dans le buffer m_cBuf
	DWORD i,j;
	clock_t t,t1,dt; 
	char c[1];

	t=clock();
	dt=(clock_t)(500*CLOCKS_PER_SEC/1000);//500 ms
	i=0;
	do
	{
		ok=ReadFile(hCom,c,1,&j,NULL);
		if (ok && j!=0 && c[0]!='\r' && c[0]!='\n')
		{
			if (i<m_iTailleBuf-1)
			{
				m_cBuf[i]=c[0];
				i++;
			}
			t=clock();
		}
		t1=clock();
	}
	while (c[0]!='\r' && c[0]!='\n' && t1<t+dt);
	m_cBuf[i]='\0';
	if (i>=m_iTailleBuf-2) AfxMessageBox("Dpassement taille m_cBuf !");
	if (i==0) ok=FALSE;
	return ok;
}
//__________________________________________________
CString CTektro::Identification()
{
	CString s;
	BOOL ok;

	ok=WriteCom("ID?\n");
	if (!ok)
	{
		//AfxMessageBox("Erreur d'criture sur port srie !");
		s="";
	}
	else
	{	
		ok=ReadCom();
		if (ok) s=m_cBuf; else s="";
	}

	return s;
}
//__________________________________________________
BOOL CTektro::SelectionVoie(CString Voie)
{
	CString s;
	BOOL ok;	
	s.Format("SELect:%s ON\n",Voie);
	ok=WriteCom(s);
	if (ok)
	{
		s.Format("DATA:SOURCE %s\n",Voie);
		ok=WriteCom(s);
	}
	return ok;
} 
//__________________________________________________
BOOL CTektro::LectureParametres(CString Voie,int Type)
{                              
	BOOL ok;
	CString s,s1;
	short n,k;
	//Format  adapter  l'oscillo
	if (Type==0)
	{
		//Nouveau type, TDS 200 series, ...
		//Pas de n de voie  spcifier
		s1="";
	}
	else
	{
		//Ancien type, TDS 310, ...
		//N de voie  spcifier
		s1=Voie+":";
	}
  //DATa:STARt
	ok=WriteCom("DATa:STARt 1\n");
  //DATa:STOP
	ok=WriteCom("DATa:STOP 2500\n");
 	//NR_PT
	s.Format("WFMPre:%sNR_Pt?\n",s1);
	ok=WriteCom(s);
	if (ok)
	{
		ok=ReadCom();
		if (ok)
		{
			k=sscanf(m_cBuf,"%d",&m_nr_pt);
			if (k==0) ok=FALSE;
		}
	}


 	//PT_Off
	if (ok)
	{
		s.Format("WFMPre:%sPT_Off?\n",s1);
		ok=WriteCom(s);
		if (ok)
		{
			ok=ReadCom();
			if (ok)
			{
				k=sscanf(m_cBuf,"%d",&m_pt_off);
				if (k==0) ok=FALSE;
			}
		}
	}
 	//XINcr
	if (ok)
	{
		s.Format("WFMPre:%sXINcr?\n",s1);
		ok=WriteCom(s);
		if (ok)
		{
			ok=ReadCom();
			if (ok)
			{
				k=sscanf(m_cBuf,"%e",&m_xincr);
				if (k==0) ok=FALSE;
			}
		}
	}
 	//YMULt
	if (ok)
	{
		s.Format("WFMPre:%sYMULt?\n",s1);
		ok=WriteCom(s);
		if (ok)
		{
			ok=ReadCom();
			if (ok)
			{
				k=sscanf(m_cBuf,"%e",&m_ymult);
				if (k==0) ok=FALSE;
			}
		}
	}
 	//YZEro
	if (ok)
	{
		s.Format("WFMPre:%sYZERo?\n",s1);
		ok=WriteCom(s);
		if (ok)
		{
			ok=ReadCom();
			if (ok)
			{
				k=sscanf(m_cBuf,"%e",&m_yzero);
				if (k==0) ok=FALSE;
			}
		}
	}
 	//YOFf
	if (ok)
	{
		s.Format("WFMPre:%sYOFf?\n",s1);
		ok=WriteCom(s);
		if (ok)
		{
			ok=ReadCom();
			if (ok)
			{
				k=sscanf(m_cBuf,"%e",&m_yoff);
				if (k==0) ok=FALSE;
			}
		}
	}
	return ok;
}
//__________________________________________________
CString CTektro::ParaCompl(CString Voie,CString Para)
{
	CString s;
	BOOL ok;

	s.Format("MEASUrement:IMMed:SOUrce %s\n",Voie);
	ok=WriteCom(s);
	s.Format("MEASUrement:IMMed:TYPe %s\n",Para);
	ok=WriteCom(s);
	s.Format("MEASUrement:IMMed:VALue?\n");
	ok=WriteCom(s);
	if (ok)
	{
		ok=ReadCom();
		if (ok)
		{
			s.Format("%s-%s: %s",Voie,Para,m_cBuf);
		}
		else
			s="";
	}
	return s;
}
//__________________________________________________
BOOL CTektro::Curve(void)
{
	//Boite de dialogue progression__________________
	class CProgDlg* m_pProg;
	m_pProg=new CProgDlg();
	m_pProg->m_staticTexte.SetWindowText("Lecture CURVE en cours...");
	//Indicateur d'tat, dfinition de la plage
	m_pProg->m_progress.SetRange(0,m_iTailleBuf);

	BOOL ok=TRUE;
	//Les caractres retourns sont dans le buffer m_cBuf
	DWORD i,j;
	clock_t t,t1,dt; 
	CString s;
	char c[1];

	ok=WriteCom("CURVe?\n");
	t=clock();
	dt=(clock_t)(500*CLOCKS_PER_SEC/1000);//500 ms
	i=0;
	do
	{
		ok=ReadFile(hCom,c,1,&j,NULL);
		if (ok && j!=0 && c[0]!='\r' && c[0]!='\n')
		{
			if (i<m_iTailleBuf-1)
			{
				m_cBuf[i]=c[0];
				
				//Indicateur d'tat, dfinition de la position courante
				m_pProg->m_progress.SetPos(i);
				
				i++;
			}
			t=clock();
		}
		t1=clock();
	}
	while (c[0]!='\r' && c[0]!='\n' && t1<t+dt);

	m_cBuf[i]='\0';
	if (i>=m_iTailleBuf-2) 
	{
		s.Format("Dpassement taille m_cBuf ! (%d)",i);
		m_pProg->m_staticTexte.SetWindowText(s);Sleep(1000);
	}
	else
	{
		i=0;
	}
	if (i==0) 
		ok=FALSE;
	else
	{
		//On montre qu'on est arriv...
		for (j=i;j<m_iTailleBuf;j++) 
		{
			m_pProg->m_progress.SetPos(j);
			Sleep(1);
		}
	}

	m_pProg->DestroyWindow();
	delete m_pProg;

	return TRUE;
}
